////////////////////////////////////////////////////////////////////////////////
//
//  :  (Rouse_) 
//   Fangorn Wizards Lab 1998 - 2002
//  16  2002 18:21

//       
//      Handle   
//  var
//    Handle : HWND;
//  begin
//    Handle:= FindWindowEx(FindWindow(   'Form1',nil), 0,    'Button1',  nil),  0, true);

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls;

type
  TMainForm = class(TForm)
    TreeView1: TTreeView;
    procedure FormCreate(Sender: TObject);
    procedure Sys_Windows_Tree(Node: TTreeNode; AHandle: HWND);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

////////////////////////////////////////////////////////////////////////////////
//
//   ,      
//

procedure TMainForm.FormCreate(Sender: TObject);
var
  StartHandle : THandle;
begin 
  //       
  // 2      
  StartHandle := GetDeskTopWindow;
  //StartHandle := 67324;//FindWindow(PChar(Caption), nil);  //  
  Sys_Windows_Tree(nil, StartHandle);
end;

////////////////////////////////////////////////////////////////////////////////
//
//   ,     , ,   ..
//           
//

procedure TMainForm.Sys_Windows_Tree(Node: TTreeNode; AHandle: HWND);
const
  MAX = 128;
var
  szClassName, szCaption: array[0..MAX - 1] of Char;
  Result    : String;
  szFileName : array[0..255] of Char;
  PID, TID: Cardinal;
  szLayoutName: array[0..MAX - 1] of Char;
begin
  //     
  while AHandle <> 0 do
  begin
    //   
    GetClassName(AHandle, szClassName, MAX);
    //  ( Caption) 
    GetWindowText(AHandle, szCaption, MAX);
    //   
    if GetwindowModuleFilename(AHandle, szFileName, SizeOf(szFileName)) = 0 then
      FillChar(szFileName, 256, #0);
    TID := GetWindowThreadProcessId(AHandle, PID);

    AttachThreadInput(GetCurrentThreadId, TID, True);
    VerLanguageName(GetKeyboardLayout(TID) and $FFFF, szLayoutName, MAX);
    AttachThreadInput(GetCurrentThreadId, TID, False);

    Result := Format('%s [%s] Caption = %s, Handle = %d, PID = %d, Layout = %s',
      [String(szClassName), String(szFileName), String(szCaption),
      AHandle, PID, String(szLayoutName)]);

    //  ,  ,  
    // ,       
    //      Sys_Windows_Tree
    Sys_Windows_Tree(TreeView1.Items.AddChild(Node, Result),
      GetWindow(AHandle, GW_CHILD));
    //   ( ) 
    AHandle := GetNextWindow(AHandle, GW_HWNDNEXT);
    //Handle := 0;
  end;
end; 


end.
